import sc2
import random
from sc2 import *
from sc2 import run_game, maps, Race, Difficulty
from sc2.player import Bot, Computer
from sc2.ids import unit_typeid, upgrade_id
from sc2.ids.ability_id import AbilityId
from sc2.position import Point2, Pointlike


class NikBot(sc2.BotAI):

    shouldexpand = False
    bayresearchlevel = 0
    armoryresearchlevel = 0
    framespersecond = 22.4

    async def on_start(self):
        return

    async def on_step(self, iteration: int):

        if self.enemy_units:
            self.client.game_step = 1
        elif self.enemy_structures:
            self.client.game_step = 2
        else:
            self.client.game_step = 8

        await self.manageworkers()
        await self.managemarines()
        await self.managemedivacs()
        await self.managehellions()
        await self.managewidowmines()
        await self.managesupplydepots()

        if iteration == 0:
            message = random.choice(["BEEP BOOP I AM A HUMAN", "gl hf", "Ah.. you again.", "me win, you lose.", "me lose, you win. wait...", "This is a haiku. It says I will win this game. Ha ha ha ha ha"])
            await self.chat_send(message)
            for worker in self.workers:
                worker.gather(self.mineral_field.closest_to(worker))

        if iteration == 10:
            await self.chat_send("Nikbot v1.03")

        if iteration % 15 == 0:
            await self.distribute_workers()

        if self.shouldexpand:
            if self.can_afford(unit_typeid.COMMANDCENTER) and await self.get_next_expansion() and not self.already_pending(unit_typeid.COMMANDCENTER):
                await self.expand_now()
            if 40 < self.supply_used < 80 and len(self.townhalls) > 1:
                self.shouldexpand = False
            elif 80 < self.supply_used < 120 and len(self.townhalls) >2:
                self.shouldexpand = False
            elif 120 < self.supply_used and len(self.townhalls) > 3:
                self.shouldexpand = False
            elif self.supply_used > 160:
                self.shouldexpand = False
        else:
            await self.trainworkers()
            await self.trainmarines()
            await self.trainmedivacs()
            await self.bayresearch()
            await self.armoryresearch()
            await self.trainhellions()
            await self.trainwidowmines()
            await self.buildsupplydepots()
            await self.buildbarracks()
            await self.buildrefinery()
            await self.buildengineeringbay()
            await self.buildarmory()
            await self.buildfactories()
            await self.buildstarports()
            if self.townhalls and self.units:
                if self.supply_used > 40 and len(self.townhalls) == 1:
                    self.shouldexpand = True
                elif self.supply_used > 80 and len(self.townhalls) == 2:
                    self.shouldexpand = True
                elif self.supply_used > 120 and len(self.townhalls) == 3:
                    self.shouldexpand = True
                elif self.minerals > 2000 and self.supply_used > 150:
                    self.shouldexpand = True

    async def armoryresearch(self):
        if self.townhalls and self.workers and self.structures:
            armories = self.structures.filter(lambda unit: unit.type_id == unit_typeid.ARMORY)
            if armories:
                if self.can_afford(upgrade_id.TERRANVEHICLEWEAPONSLEVEL1) and self.armoryresearchlevel == 0:
                    if self.research(upgrade_id.TERRANVEHICLEWEAPONSLEVEL1):
                        self.armoryresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANVEHICLEANDSHIPARMORSLEVEL1) and self.armoryresearchlevel == 1:
                    if self.research(upgrade_id.TERRANVEHICLEANDSHIPARMORSLEVEL1):
                        self.armoryresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANVEHICLEWEAPONSLEVEL2) and self.armoryresearchlevel == 2:
                    if self.research(upgrade_id.TERRANVEHICLEWEAPONSLEVEL2):
                        self.armoryresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANVEHICLEANDSHIPARMORSLEVEL2) and self.armoryresearchlevel == 3:
                    if self.research(upgrade_id.TERRANVEHICLEANDSHIPARMORSLEVEL2):
                        self.armoryresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANVEHICLEWEAPONSLEVEL3) and self.armoryresearchlevel == 4:
                    if self.research(upgrade_id.TERRANVEHICLEWEAPONSLEVEL3):
                        self.armoryresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANVEHICLEANDSHIPARMORSLEVEL3) and self.armoryresearchlevel == 5:
                    if self.research(upgrade_id.TERRANVEHICLEANDSHIPARMORSLEVEL3):
                        self.armoryresearchlevel += 1

    async def bayresearch(self):
        if self.townhalls and self.workers and self.structures:
            bays = self.structures.filter(lambda unit: unit.type_id == unit_typeid.ENGINEERINGBAY)
            if bays:
                if self.can_afford(upgrade_id.TERRANINFANTRYWEAPONSLEVEL1) and self.bayresearchlevel == 0:
                    if self.research(upgrade_id.TERRANINFANTRYWEAPONSLEVEL1):
                        self.bayresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANINFANTRYARMORSLEVEL1) and self.bayresearchlevel == 1:
                    if self.research(upgrade_id.TERRANINFANTRYARMORSLEVEL1):
                        self.bayresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANINFANTRYWEAPONSLEVEL2) and self.bayresearchlevel == 2:
                    if self.research(upgrade_id.TERRANINFANTRYWEAPONSLEVEL2):
                        self.bayresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANINFANTRYARMORSLEVEL2) and self.bayresearchlevel == 3:
                    if self.research(upgrade_id.TERRANINFANTRYARMORSLEVEL2):
                        self.bayresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANINFANTRYWEAPONSLEVEL3) and self.bayresearchlevel == 4:
                    if self.research(upgrade_id.TERRANINFANTRYWEAPONSLEVEL3):
                        self.bayresearchlevel += 1
                elif self.can_afford(upgrade_id.TERRANINFANTRYARMORSLEVEL3) and self.bayresearchlevel == 5:
                    if self.research(upgrade_id.TERRANINFANTRYARMORSLEVEL3):
                        self.bayresearchlevel += 1

    async def buildsupplydepots(self):
        if self.townhalls and self.workers:
            if self.can_afford(unit_typeid.SUPPLYDEPOT) and self.supply_left < 15 and self.already_pending(unit_typeid.SUPPLYDEPOT) < len(self.townhalls) + 1\
                    and self.supply_cap != 200:
                await self.build(unit_typeid.SUPPLYDEPOT,
                                 near=self.townhalls.random.position.towards(self.game_info.map_center,
                                                                             distance=random.randint(4, 11)))

    async def buildarmory(self):
        if self.townhalls and self.workers and self.structures:
            factories = self.structures.filter(lambda unit: unit.type_id == unit_typeid.FACTORY and unit.is_ready)
            if factories:
                armories = self.structures.filter(lambda unit: unit.type_id == unit_typeid.ARMORY)
                if not armories and self.can_afford(unit_typeid.ARMORY) and not self.already_pending(unit_typeid.ARMORY):
                    await self.build(unit_typeid.ARMORY, near=factories.closest_to(self.start_location).position.towards(self.game_info.map_center, distance=random.randint(2,4)))

    async def buildbarracks(self):
        if self.townhalls and self.workers and self.can_afford(unit_typeid.BARRACKS) and self.structures:
            depots = self.structures.filter(lambda unit: (unit.type_id == unit_typeid.SUPPLYDEPOT or unit.type_id == unit_typeid.SUPPLYDEPOTLOWERED) and unit.is_ready)
            factories = self.structures.filter(lambda unit: unit.type_id == unit_typeid.FACTORY and unit.is_ready)
            if depots:
                shouldbuild = False
                barracks = self.structures.filter(lambda unit: unit.type_id == unit_typeid.BARRACKS)
                if barracks:
                    if factories:
                        if len(barracks) < len(self.townhalls) * 3:
                            if self.already_pending(unit_typeid.BARRACKS) < len(self.townhalls) * 2:
                                shouldbuild = True
                    else:
                        if len(barracks) < 4:
                            if self.already_pending(unit_typeid.BARRACKS) < 2:
                                shouldbuild = True
                else:
                    if self.already_pending(unit_typeid.BARRACKS) < len(self.townhalls) * 2:
                        shouldbuild = True
                if shouldbuild:
                    await self.build(unit_typeid.BARRACKS,
                                     near=self.townhalls.random.position.towards(self.game_info.map_center,
                                                                                 distance=random.randint(4, 11)))

    async def buildfactories(self):
        if self.townhalls and self.workers and self.can_afford(unit_typeid.FACTORY) and self.structures:
            barracks = self.structures.filter(lambda unit: unit.type_id == unit_typeid.BARRACKS)
            if barracks:
                shouldbuild = False
                factories = self.structures.filter(lambda unit: unit.type_id == unit_typeid.FACTORY)
                if factories:
                    if len(factories) < len(self.townhalls) * 2:
                        if self.already_pending(unit_typeid.FACTORY) < len(self.townhalls):
                            shouldbuild = True
                else:
                    if self.already_pending(unit_typeid.FACTORY) < len(self.townhalls):
                        shouldbuild = True
                if shouldbuild:
                    await self.build(unit_typeid.FACTORY, near=barracks.random.position.towards(self.game_info.map_center, distance= random.randint(2,4)))

    async def buildstarports(self):
        if self.townhalls and self.workers and self.can_afford(unit_typeid.STARPORT) and self.structures:
            factories = self.structures.filter(lambda unit: unit.type_id == unit_typeid.FACTORY)
            if factories:
                shouldbuild = False
                starports = self.structures.filter(lambda unit: unit.type_id == unit_typeid.STARPORT)
                if starports:
                    if len(starports) < len(self.townhalls) * 2:
                        if self.already_pending(unit_typeid.STARPORT) < len(self.townhalls):
                            shouldbuild = True
                else:
                    if self.already_pending(unit_typeid.STARPORT) < len(self.townhalls):
                        shouldbuild = True
                if shouldbuild:
                    await self.build(unit_typeid.STARPORT, near=factories.random.position.towards(self.townhalls.random, distance=random.randint(2,4)))

    async def buildengineeringbay(self):
        if self.townhalls and self.workers and self.can_afford(unit_typeid.ENGINEERINGBAY) and self.structures:
            engineeringbays = self.structures.filter(lambda unit: unit.type_id == unit_typeid.ENGINEERINGBAY)
            barracks = self.structures.filter(lambda unit: unit.type_id == unit_typeid.BARRACKS and unit.is_ready)
            if not engineeringbays and barracks:
                if not self.already_pending(unit_typeid.ENGINEERINGBAY):
                    await self.build(unit_typeid.ENGINEERINGBAY, near=self.townhalls.random.position.towards(self.game_info.map_center, distance=random.randint(4,8)))


    async def buildrefinery(self):
        if self.structures:
            barracks = self.structures.filter(lambda unit: unit.type_id == unit_typeid.BARRACKS and unit.is_ready)
            refineries = self.structures.filter(lambda unit: unit.type_id == unit_typeid.REFINERY)
            if len(refineries) >= 4:
                return
            if self.workers and self.townhalls and self.can_afford(unit_typeid.REFINERY) and barracks and not self.already_pending(unit_typeid.REFINERY):
                targetgeyser = None
                geysers = self.vespene_geyser
                commandcenters = self.townhalls.filter(lambda structure: structure.is_ready)
                for cc in commandcenters:
                    if refineries:
                        if refineries.closest_to(cc).distance_to(cc) > 20 and len(refineries) < 4:
                            geysers = geysers.filter(lambda unit: unit.distance_to(cc) < 10)
                            if geysers:
                                targetgeyser = random.choice(geysers)
                                break
                    else:
                        geysers = geysers.filter(lambda unit: unit.distance_to(cc) < 10)
                        if geysers:
                            targetgeyser = random.choice(geysers)
                            break
                if targetgeyser:
                    builder = self.select_build_worker(targetgeyser)
                    if builder:
                        builder.build_gas(targetgeyser)

    async def trainmarines(self):
        if self.townhalls and self.workers:
            if self.can_afford(unit_typeid.MARINE) and self.supply_left > 0:
                self.train(unit_typeid.MARINE)

    async def trainhellions(self):
        if self.townhalls and self.workers and self.units:
            hellions = self.units.filter(lambda unit: unit.type_id == unit_typeid.HELLION)
            if hellions:
                if len(hellions) < len(self.townhalls) * 3:
                    self.train(unit_typeid.HELLION)
            elif self.can_afford(unit_typeid.HELLION) and self. supply_left > 5:
                self.train(unit_typeid.HELLION)

    async def trainwidowmines(self):
        if self.townhalls and self.workers and self.units:
            widowmines = self.units.filter(lambda unit: unit.type_id == unit_typeid.WIDOWMINE or unit.type_id == unit_typeid.WIDOWMINEBURROWED)
            if widowmines:
                if len(widowmines) < len(self.townhalls):
                    self.train(unit_typeid.WIDOWMINE)
            elif self.can_afford(unit_typeid.WIDOWMINE) and self.supply_left > 5:
                    self.train(unit_typeid.WIDOWMINE)

    async def trainmedivacs(self):
        if self.townhalls and self.workers:
            if self.can_afford(unit_typeid.MEDIVAC) and self.supply_left > 5:
                self.train(unit_typeid.MEDIVAC)

    async def trainworkers(self):
        if self.townhalls:
            if self.can_afford(unit_typeid.SCV) and self.supply_left > 0:
                if self.workers:
                    if len(self.workers) < len(self.townhalls) * 25 and len(self.workers) < 80:
                        self.train(unit_typeid.SCV)
                else:
                    self.train(unit_typeid.SCV)

    async def managemarines(self):
        if self.units:
            marines = self.units.filter(lambda unit: unit.type_id == unit_typeid.MARINE)
            if marines:
                for marine in marines:
                    if marine.tag not in self.unit_tags_received_action:
                        if self.enemy_units:
                            noncloaked = self.enemy_units.filter(lambda unit: not unit.is_cloaked and not unit.type_id == unit_typeid.EGG and not unit.type_id == unit_typeid.LARVA)
                            if noncloaked:
                                target = noncloaked.closest_to(marine)
                                if target:
                                    if target.distance_to(marine) < 10:
                                        if (target.type_id == unit_typeid.BANELING or target.type_id == unit_typeid.ZEALOT or target.type_id == unit_typeid.ULTRALISK or target.type_id == unit_typeid.WIDOWMINEBURROWED) and target.distance_to(marine) < 8:
                                            await self.kite(marine, target)
                                        else:
                                            await self.stutterstep(marine, target)
                                    else:
                                        marine.attack(target.position)
                            elif self.enemy_structures:
                                target = self.enemy_structures.closest_to(marine)
                                if target:
                                    if target.ground_dps > 0:
                                        await self.kite(marine, target)
                                    else:
                                        marine.attack(target.position)
                        elif self.enemy_structures:
                            target = self.enemy_structures.closest_to(marine)
                            if target:
                                if target.ground_dps > 0:
                                    await self.kite(marine, target)
                                else:
                                    marine.attack(target)
                        elif self.supply_used > 150:
                            if not marine.is_active:
                                locations = self.expansion_locations_list
                                target = random.choice(locations).towards(random.choice(locations),
                                                                  distance=random.randint(2, 5))
                                marine.move(target)
                        elif self.townhalls:
                            if self.townhalls.closest_to(marine).distance_to(marine) > 20:
                                marine.move(
                                    self.townhalls.closest_to(marine).position.towards(self.townhalls.random, distance=4))

    async def managehellions(self):
        if self.units:
            hellions = self.units.filter(lambda unit: unit.type_id == unit_typeid.HELLION)
            if hellions:
                for hellion in hellions:
                    if hellion.tag not in self.unit_tags_received_action:
                        if self.enemy_units:
                            noncloaked = self.enemy_units.filter(lambda unit: not unit.is_cloaked)
                            if noncloaked:
                                onground = noncloaked.filter(lambda unit: not unit.is_flying)
                                if onground:
                                    target = onground.closest_to(hellion)
                                    if (
                                            target.type_id == unit_typeid.BANELING or target.type_id == unit_typeid.ZEALOT) and target.distance_to(
                                            hellion) < 8:
                                        await self.kite(hellion, target)
                                    else:
                                        await self.stutterstep(hellion, target)
                            elif self.enemy_structures:
                                target = self.enemy_structures.closest_to(hellion)
                                if target:
                                    if target.ground_dps > 0:
                                        await self.kite(hellion, target)
                                    else:
                                        hellion.attack(target)
                        elif self.enemy_structures:
                            target = self.enemy_structures.closest_to(hellion)
                            if target:
                                if hellion.weapon_ready:
                                    hellion.attack(target)
                                elif hellion.weapon_cooldown:
                                    await self.stutterstep(hellion, target)
                        elif self.supply_used == 100:
                            if not hellion.is_moving:
                                locations = self.expansion_locations_list
                                target = random.choice(locations).towards(random.choice(locations),
                                                                  distance=random.randint(2, 5))
                                hellion.attack(target)
                        elif self.townhalls:
                            if self.townhalls.closest_to(hellion).distance_to(hellion) > 20:
                                hellion.move(
                                    self.townhalls.closest_to(hellion).position.towards(self.townhalls.random, distance=4))

    async def managemedivacs(self):
        if self.units:
            medivacs = self.units.filter(lambda unit: unit.type_id == unit_typeid.MEDIVAC)
            if medivacs:
                biologicalunits = self.units.filter(lambda unit: unit.is_biological)
                marines = self.units.filter(lambda unit: unit.type_id == unit_typeid.MARINE)
                if biologicalunits:
                    damagedunits = biologicalunits.filter(lambda unit: unit.health_percentage < 100)
                    if damagedunits:
                        for medivac in medivacs:
                            if damagedunits.closest_to(medivac).distance_to(medivac) > 4:
                                medivac.move(damagedunits.closest_to(medivac))
                    elif marines:
                        for medivac in medivacs:
                            if marines.closest_to(medivac).distance_to(medivac) > 3.5:
                                medivac.move(marines.closest_to(medivac))
                    else:
                        for medivac in medivacs:
                            if biologicalunits.closest_to(medivac).distance_to(medivac) > 3.5:
                                medivac.move(biologicalunits.closest_to(medivac))

    async def managewidowmines(self):
        if self.units:
            widowmines = self.units.filter(lambda unit: unit.type_id == unit_typeid.WIDOWMINE)
            if widowmines:
                if self.townhalls:
                    for widowmine in widowmines:
                        if widowmine.is_idle:
                            atlocation = False
                            locations = []
                            for location in self.expansion_locations_list:
                                if location.distance_to(self.enemy_start_locations[0]) < location.distance_to(self.start_location):
                                    locations.append(location)
                            if locations:
                                for location in locations:
                                    if location.distance_to(widowmine) < 3:
                                        atlocation = True
                            if atlocation:
                                widowmine(AbilityId.BURROWDOWN_WIDOWMINE)
                            else:
                                widowmine.move(random.choice(self.expansion_locations_list))
                else:
                    for widowmine in widowmines:
                        widowmine(AbilityId.BURROWDOWN_WIDOWMINE)

    async def manageworkers(self):
        if self.workers and self.townhalls:
            for worker in self.workers:
                if worker.is_carrying_minerals:
                    worker.return_resource()
                elif worker.is_idle:
                    if self.structures:
                        damagedstructures = self.structures.filter(lambda unit: unit.health_percentage < 100)
                        if damagedstructures:
                            worker.repair(damagedstructures.closest_to(worker))
                        else:
                            worker.gather(self.mineral_field.closest_to(self.townhalls.closest_to(worker)))

    async def managesupplydepots(self):
        supplydepots = self.structures.filter(lambda
                                                  structure: structure.type_id == unit_typeid.SUPPLYDEPOT and structure.is_ready and not structure.type_id == unit_typeid.SUPPLYDEPOTLOWERED)
        lowereddepots = self.structures.filter(lambda
                                                   structure: structure.type_id == unit_typeid.SUPPLYDEPOTLOWERED and structure.is_ready and not structure.type_id == unit_typeid.SUPPLYDEPOT)
        if supplydepots:
            for depot in supplydepots:
                if depot.tag not in self.unit_tags_received_action:
                    if not self.enemy_units:
                        depot(AbilityId.MORPH_SUPPLYDEPOT_LOWER)
                    else:
                        enemygroundunits = self.enemy_units.filter(
                            lambda unit: not unit.is_structure and not unit.is_flying)
                        if enemygroundunits:
                            if enemygroundunits.closest_to(depot).distance_to(depot) > 10:
                                depot(AbilityId.MORPH_SUPPLYDEPOT_LOWER)
        if lowereddepots:
            for depot in lowereddepots:
                if depot.tag not in self.unit_tags_received_action:
                    if self.enemy_units:
                        enemygroundunits = self.enemy_units.filter(
                            lambda unit: not unit.is_structure and not unit.is_flying)
                        if enemygroundunits:
                            if enemygroundunits.closest_to(depot).distance_to(depot) < 4:
                                depot(AbilityId.MORPH_SUPPLYDEPOT_RAISE)

    async def kite(self, unit, enemyunit):
        # call this if you want the unit to keep running away as long as its weapon is on cooldown
        unitx = unit.position.x
        unity = unit.position.y
        enemyunitx = enemyunit.position.x
        enemyunity = enemyunit.position.y
        distance = unit.distance_to(enemyunit)

        retreatx = ((unitx - enemyunitx) / distance) + unitx
        retreaty = ((unity - enemyunity) / distance) + unity

        retreatposition = await self.converttopoint2(retreatx, retreaty)

        if not unit.tag in self.unit_tags_received_action:
            if unit.weapon_cooldown == 0:
                unit.attack(enemyunit)
            else:
                unit.move(retreatposition)
        else:
            return

    async def stutterstep(self, unit, enemyunit):
        # call this if you want the unit to not just run away
        # we need to make sure we don't give multiple commands to a unit in one frame.
        if unit.tag not in self.unit_tags_received_action:
            unitx = unit.position.x
            unity = unit.position.y
            unitspeed = unit.calculate_speed()
            enemyunitx = enemyunit.position.x
            enemyunity = enemyunit.position.y
            enemyspeed = enemyunit.movement_speed * 1.4 # need to multiply by 1.4 to get speed on "faster" setting,
            retreatx = unitx
            retreaty = unity
            attackx = unitx
            attacky = unity
            enemydistanceperstep = enemyspeed / self.framespersecond
            distance = unit.distance_to(enemyunit)
            unitstepstoenemy = distance / unit.distance_per_step

            if enemydistanceperstep:
                enemystepstounit = distance / enemydistanceperstep
            else:
                enemystepstounit = 1000000000
            weaponcooldown = unit.weapon_cooldown

            # retreat position should be the distance we can move per step directly away from the enemy.
            # attack position should be enemy unit position + radius + our unit's attack range + radius
            # if the enemy's x coordinate is > ours, we want to move in the negative x direction
            if enemyunitx > unitx:
                retreatx = unitx - unit.distance_per_step
                # if the enemy is flying, our attack range is our air range.
                if enemyunit.is_flying:
                    attackx = enemyunitx - 0.1
                # otherwise it's our ground range.
                else:
                    attackx = enemyunitx - 0.1

            # if our x coordinates are equal, move on the same x coordinate
            elif enemyunitx == unitx:
                retreatx = unitx
                attackx = unitx
            # if our's is greater, move in the positive x direction
            else:
                retreatx = unitx + unit.distance_per_step
                if enemyunit.is_flying:
                    attackx = enemyunitx + 0.1
                # otherwise it's our ground range.
                else:
                    attackx = enemyunitx + 0.1

            # if the enemy's y coordinate is > ours, we want to move in the negative y direction
            if enemyunity > unity:
                retreaty = unity - unit.distance_per_step
                if enemyunit.is_flying:
                    attacky = enemyunity - 0.1
                # otherwise it's our ground range.
                else:
                    attacky = enemyunity - 0.1
            # if our y coordinates are equal, move on the same y coordinate
            elif enemyunity == unity:
                retreaty = unity
                attacky = unity
            # if our's is greater, move in the positive y direction
            else:
                retreaty = unity + unit.distance_per_step
                if enemyunit.is_flying:
                    attacky = enemyunity + 0.1
                # otherwise it's our ground range.
                else:
                    attacky = enemyunity + 0.1

            retreatposition = await self.converttopoint2(retreatx, retreaty)
            attackposition = await self.converttopoint2(attackx, attacky)


            # if our weapon is ready to fire, attack
            if weaponcooldown == 0:
                # if the target is in our range, attack the target
                if unit.target_in_range(enemyunit):
                    unit.attack(enemyunit)
                # otherwise move towards the attack position so they don't know we're attacking them.
                else:
                    unit.attack(attackposition)

            # if the enemy is attacking us, it should be facing us? and active.
            elif enemyunit.is_facing(unit):
                # the enemy is either attacking us or moving towards us

                # we should do things differently depending on if we're faster or slower than the enemy
                if unitspeed > enemyspeed:
                    # do stuff if we're faster

                    # if our weapon cooldown > time it takes to get to the enemy, run away.
                    if weaponcooldown > unitstepstoenemy / self.framespersecond:
                        unit.move(retreatposition)
                    # otherwise, we should move towards the enemy to attack.
                    else:
                        unit.attack(enemyunit)

                elif unitspeed == enemyspeed:
                    # do stuff if we're the same speed
                    # if we're the same speed, we do the same thing as if we're faster.

                    # if our weapon cooldown > time it takes to get to the enemy, run away.
                    if weaponcooldown > unitstepstoenemy / self.framespersecond:
                        unit.move(retreatposition)
                    # otherwise, we should move towards the enemy to attack.
                    else:
                        unit.attack(enemyunit)

                else:
                    # do stuff if we're slower
                    # if we're slower than we use the enemy's speed to determine how long it takes to get to them.

                    # if our weapon cooldown > time it takes to get to the enemy, run away.
                    if weaponcooldown > enemystepstounit / self.framespersecond:
                        unit.move(retreatposition)
                    # otherwise, we should move towards the enemy to attack.
                    else:
                        unit.attack(enemyunit)

            # if the enemy isn't attacking us and no other enemies are, then we don't need to do anything special, just attack the enemy.
            else:
                unit.attack(enemyunit)
        return

    async def converttopoint2(self, x, y):
        pointtuple = (x, y)
        pointpointlike = Pointlike(pointtuple)
        pointpoint2 = Point2(pointpointlike)
        return pointpoint2
